Unit de28e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE28EP_p, DE32E_p, DE28ES_p, UTDE13_p;

procedure de28e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; HMAX :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean;
                var DELTY :Array of Extended; var DF :Array of Extended;
                var RF :Array of Extended; var YP :Array of Extended;
                var RY :Array of Extended; var RFN :Array of Extended;
                var IERR :Integer);

implementation

procedure de28e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; HMAX :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean;
                var DELTY :Array of Extended; var DF :Array of Extended;
                var RF :Array of Extended; var YP :Array of Extended;
                var RY :Array of Extended; var RFN :Array of Extended;
                var IERR :Integer);
var
L,I,K,IM,JER,K1 :Integer;
EPS1,EPS2,ALP :Extended;
BUL1,BUL2 :Boolean;
RX :Array [0..4] of Extended;
const
C1 :Extended = 0.5e0;
C2 :Extended = 0.41666666666666666667e0;
C3 :Extended = 0.375e0;
C4 :Extended = -0.026388888888888888889e0;
C5 :Extended = 14.210526315789473684e0;
C6 :Extended = 0.03125e0;
IORDER :Integer = 5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26;
begin
L := 1;
BUL1 := False;
EPS1 := C5*EPS;
EPS2 := C6*EPS;
if ( JSTART >= 0 )
 then goto _3;
IM := 0;
if ( IERR = 0 )
 then goto _1;
IERR := 0;
goto _5;
_1:
ALP := _COM28D.elm1/_COM28D.elm2;
if ( ALP = 0.5e0 )
 then DE28EP(M,IORDER,ALP,DF);
_COM28D.elm2 := _COM28D.elm1;
for K:=1 to 4 do
 begin
  K1 := K+1;
  for I:=1 to M do
   begin
    DF[(I-1)+(K-1)*M] := DF[(I-1)+(K-1)*M]-DF[(I-1)+(K1-1)*M];
_2:
   end;
 end;
goto _5;
_3:
_COM28D.elm3 := X;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_4:
 end;
IERR := 0;
if ( JSTART <> 0 )
 then goto _5;
IM := 0;
F(X,YX,RF,M);
DE32E(F,M,IORDER,X,YX,HMIN,EPS,P,H,DF,RX,RY,BUL,
     RFN,RF,DELTY,JER);
if ( JER = 0 )
 then goto _6;
IERR := 66;
goto _26;
_5:
if ( H = _COM28D.elm2 )
 then goto _6;
ALP := H/_COM28D.elm2;
DE28EP(M,IORDER,ALP,DF);
_6:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1]+DF[(I-1)+0*M]+DF[(I-1)+1*M]*C1+DF[(I-1)+2*M]*C2+DF[(I-1)+3*M]*C3;
  RF[I-1] := DF[(I-1)+0*M]+DF[(I-1)+1*M]+DF[(I-1)+2*M]+DF[(I-1)+3*M];
_7:
 end;
X := _COM28D.elm3+H;
_8:
for I:=1 to M do
 begin
  DELTY[I-1] := -RF[I-1]*C3;
_9:
 end;
F(X,YX,RF,M);
BUL2 := True;
for I:=1 to M do
 begin
  RF[I-1] := RF[I-1]*H;
  DELTY[I-1] := DELTY[I-1]+RF[I-1]*C3;
  YX[I-1] := DELTY[I-1]+YX[I-1];
  if ( Abs(YX[I-1]) <= P ) 
   then goto _10;
  DELTY[I-1] := DELTY[I-1]/YX[I-1];
_10:
  if ( Abs(DELTY[I-1]) > EPS ) 
   then BUL2 := False;
_11:
 end;
if ( BUL2 ) 
 then goto _18;
case L of
 1: goto _12;
 2: goto _14;
end;
_12:
for I:=1 to M do
 begin
  if ( Abs(DELTY[I-1]) > EPS1 ) 
   then goto _14;
_13:
 end;
L := 2;
goto _8;
_14:
if ( not BUL1 ) 
 then goto _15;
IERR := 65;
goto _26;
_15:
H := H*0.5e0;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _16;
BUL1 := True;
ALP := Sign(HMIN,H)*0.5e0/H;
H := Sign(HMIN,H);
goto _17;
_16:
ALP := 0.5e0;
_17:
DE28EP(M,IORDER,ALP,DF);
IM := 2;
goto _6;
_18:
DE28ES(M,IORDER,RF,DF,DELTY);
_COM28D.elm1 := H;
for I:=1 to M do
 begin
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  YX[I-1] := YX[I-1]+DELTY[I-1];
_19:
 end;
_20:
for I:=1 to M do
 begin
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  if ( Abs(YX[I-1]) <= P ) 
   then goto _21;
  DELTY[I-1] := DELTY[I-1]/YX[I-1];
_21:
  if ( Abs(DELTY[I-1]) > EPS2 ) 
   then goto _25;
_22:
 end;
IM := IM+1;
if ( IM <> 3 ) 
 then goto _26;
H := H*2.e0;
BUL1 := False;
if ( Abs(H) <= Abs(HMAX) ) 
 then goto _23;
ALP := Sign(HMAX,H)*2.e0/H;
H := Sign(HMAX,H);
goto _24;
_23:
ALP := 2.e0;
_24:
DE28EP(M,IORDER,ALP,DF);
IM := 0;
goto _20;
_25:
IM := 0;
_26:
if ( IERR <> 0 ) 
 then UTDE13(IERR,28);
JSTART := 1;
_COM28D.elm2 := H;
end;

end.
